
// ----------------------------------------------

#declare T_Planta = texture {
	pigment {
		color rgb <0.035, 1, 0>
		}
	finish	{
		ambient 0.5
		diffuse 0.6
		specular 0.4
		phong 0.9 phong_size 250
		}
	}

// ----------------------------------------------

#declare Bulbo = sor {
	6,
	<0, 0.0357284>, <0, -0.125041>, <0.410686, 0.291073>,
	<0.419617, 0.637484>, <0, 1.3573>, <0, 1.3573>
	sturm
	translate <0, 0.1, 0>
	}

// ----------------------------------------------

#declare Boca0 = difference {
	object	{ Bulbo }
	object	{ Bulbo
		scale <0.9, 0.9, 0.9>
		translate <0, 0.1, 0>
		}
	box	{
		<-0.6, 0, -0.6>, <0, 1.5, 0.6>
		}
	}

// ----------------------------------------------

#macro Boca(A)
	union	{
		object	{ Boca0
			rotate <0, 0, -A>
			}
		object	{ Boca0
			rotate <0, 180, A>
			}
		}
#end

// ----------------------------------------------

#declare Hoja0 = intersection {
	sphere	{ <0.2, 0, 0>, 0.6 }
	sphere	{ <-0.2, 0, 0>, 0.6 }
	box 	{ <-0.4, -0.6, -0.01>, <0.4, 0.6, 0.01> }
	translate <0, 0.45, 0>
	}

// ----------------------------------------------

#macro Hojas(A)
	union	{
		object	{ Hoja0
			rotate <-A, 0, 0>
			}
		object	{ Hoja0
			rotate <A, 0, 0>
			}
		}
#end

// ----------------------------------------------

#macro Tronco(R1,R2,L)
	union	{
		cone	{ <0,0,0> R1 <0,L,0> R2 }
		sphere	{ <0,L,0> R2 }
		}
#end

// ----------------------------------------------

#macro Carnivora(A1,A2,A3,A4,AB)
#local R=0.15;
#local L=0.15;
#local K=0.9;
union	{
	Tronco(R,R*K,L)
	object	{
		Hojas(60)
		translate y*L*0.9
		rotate y*90
		}
	union	{
		#declare R=R*K;
		#declare L=L*K;
		Tronco(R,R*K,L)
		union	{
			#declare R=R*K;
			#declare L=L*K;
			Tronco(R,R*K,L)
			union	{
				#declare R=R*K;
				#declare L=L*K;
				Tronco(R,R*K,L)
				union	{
					#declare R=R*K;
					#declare L=L*K;
					Tronco(R,R*K,L)
					object	{
						Boca(AB)
						translate y*L
						}
					object	{
						Hojas(60)
						translate y*L*0.9
						}
					rotate z*A4
					translate y*L
					}
				rotate z*A3
				translate y*L
				}
			rotate z*A2
			translate y*L
			}
		rotate z*A1
		translate y*L
		}
	texture { T_Planta }
	rotate <-15,-10,0>
	scale	SKALE
	}
#end

