#include "ortomac.inc"

OrtoCamera(image_width,image_height,0,0)
//OrtoCamera(image_width,image_width*3/4,0,0)
OrtoLightS()

// ----------------------------------------------


#declare T_Piel1 = texture {
	pigment { color rgb <1,0.0,0.0> }
	finish	{ ambient 0.3 diffuse 0.8 phong 1 phong_size 250 }
	}

#declare T_Piel2 = texture {
	pigment { color rgb <1,0.5,0.0> }
	finish	{ ambient 0.3 diffuse 0.8 phong 1 phong_size 250}
	}

#declare T_Piel3 = texture {
	pigment { color rgb <0.5,1.0,0.0> }
	finish	{ ambient 0.3 diffuse 0.8 phong 1 phong_size 250 }
	}

#declare T_Rabo = texture {
	pigment { color rgb <1,0.5,0.0> }
	finish	{ ambient 0.3 diffuse 0.8 }
	}

#declare T_Hojas = texture {
	pigment { color rgb <0.25,0.6,0.0> }
	finish	{ ambient 0.3 diffuse 0.8 }
	}

// ----------------------------------------------

#declare T=0.8;
#declare S=1;

#declare L1=1.0;
#declare R1=2.9;

#declare H=-1.5;
#declare L2=0.6;
#declare R2=2.2;

#declare R0=1.5;
#declare H0=1.9;

#declare Cuerpo =
	blob	{
		threshold T

		sphere	{ <0, H0, 0>, R0, -S texture {T_Piel3} }

		sphere	{ <-L1, 0, -L1>, R1, S texture {T_Piel3} }
		sphere	{ <-L1, 0,  L1>, R1, S texture {T_Piel2} }
		sphere	{ < L1, 0, -L1>, R1, S texture {T_Piel1} }
		sphere	{ < L1, 0,  L1>, R1, S texture {T_Piel2} }

		sphere	{ <-L2, H, -L2>, R2, S texture {T_Piel2} }
		sphere	{ <-L2, H,  L2>, R2, S texture {T_Piel2} }
		sphere	{ < L2, H, -L2>, R2, S texture {T_Piel2} }
		sphere	{ < L2, H,  L2>, R2, S texture {T_Piel2} }

		sturm on

		}

#declare TR1 = 2;
#declare TR2 = 0.2;

#declare Rabo = intersection {
	torus	{
		TR1, TR2
		rotate x*90
		translate <-TR1, H0/2, 0>
		}
	sphere	{
		<0,H0,0>, R0*2
		}
	texture { T_Rabo }
	}

#declare HR = 1.5;
#declare HV = 2.0;
#declare HL = 0.75;

#declare Hoja = intersection {
	sphere	{ <-HL,0,0> HV }
	sphere	{ < HL,0,0> HV }
	difference {
		sphere	{ < 0,0,HR> HR+0.05 }
		sphere	{ < 0,0,HR> HR }
		}
	translate <0,1.75,-0.5>
	texture { T_Hojas }
	scale 1
	}

#declare Fruta = union {
	object	{ Cuerpo }
	object	{ Rabo }
	object	{ Hoja rotate <100,90,0> translate <-0.1,1.9,0> }
	object	{ Hoja rotate <100,-90,0> translate <-0.1,1.9,0> }
//	scale 50
	scale 3.5
	}

// sphere { <0,0,0> 5 texture {T_Piel1} }

#if(0)
background { color rgb<0.90,0.90,0.90> }

object	{
	Fruta
	scale 20
	rotate <-30,0,0>
	}
#else
object	{
	Fruta
	rotate <-30,0,0>
	}
#end