
// ----------------------------------------------

#declare T_Alas = texture {
	pigment { color rgb <0.6,0.8,1> }
	finish	{ ambient 0.3 }
	}

#declare T_Abdomen = texture {
	pigment { color rgb <1,1,0> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

#declare T_Torax = texture {
	pigment { color rgb <0.75,1,0> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

#declare T_Cabeza = texture {
	pigment { color rgb <0.5,1,0> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

#declare T_Ojos = texture {
	pigment { color rgb <1,1,1> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

#declare T_Ojos2 = texture {
	pigment { color rgb <0,0,1> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

#declare T_Boca = texture {
	pigment { color rgb <0,0,0> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

// ----------------------------------------------

#declare RO=0.475;
#declare GO=0.025;

#declare Parpado0=intersection {
	sphere	{ <0,0,0> RO+GO }
	box	{ <-RO-GO-0.01,-RO-GO-0.01,RO+GO+0.01> <RO+GO+0.01,RO+GO+0.01,0> }
	texture { T_Cabeza }
	}

#macro OJO(A)
union	{
	sphere	{
		<0,0,0> RO
		texture { T_Ojos }
		}
	sphere	{
		<0,0,-0.09> RO-0.075
		texture { T_Ojos2 }
		}
	object	{
		Parpado0
		rotate x*A
		}
	object	{
		Parpado0
		rotate -x*A
		}
	translate < 0, 0.5, -0.6>
	}
#end

#macro Cabeza(A1)
union	{
	union	{
		sphere	{ <0,0,0> 1 }
		sphere	{
			<0,0,0> 0.3
			scale <1,1,6>
			translate -z*1.7
			}
		texture { T_Cabeza }
		}
	object	{ OJO(A1) translate x*0.5 }
	object	{ OJO(A1) translate -x*0.5 }
	rotate x*30

	scale 0.75
	translate <0,1,0>
	rotate x*30
	}
#end
// ----------------------------------------------

#macro Abdomen(A1)
sphere	{
	<0,-1,0> 1
	scale <0.75,1.5,0.75>
	translate -z*0.2
	texture { T_Abdomen }
	rotate x*A1
	}
#end

#macro Ala(A1,A2,A3)
#local G=0.03;
union	{
	sphere	{
		<0,0,0> 1.75
		translate -y*1.75
		scale <0.4,1,G>
		rotate z*A2
		}
	sphere	{
		<0,0,0> 1.75
		translate -y*1.8
		scale <0.4,1,G>
		rotate -z*A2
		}
	texture { T_Alas }
	rotate z*A1
	rotate y*A3
//	translate <0,0,0.3>
	}
#end

#declare Pata = difference {
	torus	{ 1, 0.1 }
	box	{ <-0.5,-0.5,0> <0.5,0.5,-1.5> }
	scale	<1, 1, 0.5>
	translate -z*0.5
	}

#macro Mosca(A1,A2,A3,A4,A5)
union	{
	union	{
		union	{
			sphere	{ <0, 0.4, 0> 0.6 }
			sphere	{ <0,0,0> 0.6 }
			sphere	{ <0,-0.4, 0> 0.6 }
			scale <1,0.75,1>
			}
/*
		object	{ Pata translate y*0.4 }
		object	{ Pata }
		object	{ Pata translate -y*0.4  }
*/
		texture { T_Torax }
		}
	Cabeza(A1)
	Abdomen(A2)
	union	{
		object { Ala(A3,A4,A5) translate x*0.3 }
		object { Ala(-A3,A4,-A5) translate -x*0.3 }
		translate -y*0.3
		}
	scale 5
	}
#end
