
// ----------------------------------------------

#declare T_Piel1 = texture {
	pigment { color rgb <0.0, 1.0, 0.0> }
	finish	{ ambient 0.3 diffuse 0.8 phong 1 phong_size 250 }
	}

#declare T_Ojos1 = texture {
	pigment { color rgb <1.0, 1.0, 1.0> }
	finish	{ ambient 0.3 diffuse 0.8 phong 1 phong_size 250 }
	}

#declare T_Ojos2 = texture {
	pigment { color rgb <0.0, 0.0, 0.0> }
	finish	{ ambient 0.0 diffuse 0.0 specular 1 phong 1 phong_size 250 }
	}

// ----------------------------------------------

#macro Parpado(RO,GO)
	intersection {
		sphere	{ <0,0,0> RO+GO }
		box	{ <-RO-GO-0.01,-RO-GO-0.01,RO+GO+0.01> <RO+GO+0.01,RO+GO+0.01,0> }
		texture { T_Piel1 }
		}
#end

#macro OJO(A)
#local RO=0.475;
#local GO=0.025;
union	{
	sphere	{
		<0,0,0> RO
		texture { T_Ojos1 }
		}
	sphere	{
		<0,0,-0.09> RO-0.075
		texture { T_Ojos2 }
		}
	object	{
		Parpado(RO,GO)
		rotate x*A
		}
	object	{
		Parpado(RO,GO)
		rotate -x*A
		}
	rotate -y*90
	scale 1.4
	translate < 0.2, 0.2, 0>
	}
#end
/*
#declare OJO = union {
	sphere	{
		<0,0,0> 1
		texture { T_Ojos1 }
		}
	sphere	{
		<0.75,0,0> 0.5
		texture { T_Ojos2 }
		}
	}
*/

#declare SEGMENTO = sphere {
	<0, 0, 0>, 1
	scale <1, 1, 1>
	rotate <0, 0, 0>
	translate <0, 0, 0>
	texture { T_Piel1 }
	}

#declare RO=0.7;
#declare LO=0.4;

#declare OJOS = union {
	object	{ OJO(0)
		scale RO
		translate <0,0,-LO>
		}
	object	{ OJO(0)
		scale RO
		translate <0,0,LO>
		}
	translate <0.25,0.70,0>
	}

#declare PATAS = difference {
	union	{
		cylinder {
			<0, 0.5, 0>, <0, -0.5, 0>, 0.5
			scale <0.75, 1, 0.4>
			rotate <-0, 0, 11.4>
			translate <-0.383333, 0.566667, 0>
			}
		cylinder {
			<0, 0.5, 0>, <0, -0.5, 0>, 0.5
			scale <0.75, 1, 0.4>
			rotate <0, 0, -15.1>
			translate <0.383333, 0.566667, 0>
			}
		}
	box	{
		<-1.00581, 0.944675, -0.433333>, <0.98382, 1.389, 0.433333>
		scale <1, 1, 1>
		rotate <0, 0, 0>
		translate <0, 0, 0>
		}
	rotate <0, 90, 180>
	texture { T_Piel1 }
	}

// ----------------------------------------------

#declare H0=0.5;
#declare L0=3;
#declare S=11;

#declare H1=H0+H0/2;
#declare H2=H0;
#declare L1=L0*2/3;

#macro RSEG(I)
	#local IL=L0*I/S;
	#if(IL<L1)
		H1-(L1-IL)*(H1-H0)/L1;
	#else
		H1-(IL-L1)*(H1-H2)/(L0-L1);
	#end
#end

#macro LSEG(I)
	L0*I/S-L0/2
#end

#macro GUSANO()
union	{
	#local I=0;
	#while(I<S)
		#declare R=RSEG(I)
		union	{
			object { SEGMENTO }
			#if((I>5) & (I<9))
				object { PATAS }
			#end
			#if(I=(S-1))
				object { OJOS }
			#end
			scale R
			translate <LSEG(I),R,0>
			}
		#local I=I+1;
	#end
	scale 8
	}
#end
