
#declare T_Cabeza = texture {
	pigment { color rgb <1,0.65,0.05> }
	finish	{ ambient 0.4 diffuse 0.8 specular 0.25 phong 0.5 phong_size 25 }
	}

#declare T_Patas = T_Cabeza

#declare T_Ojos = texture {
	pigment { color rgb <1,1,1> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

#declare T_Ojos2 = texture {
	pigment { color rgb <0,0,1> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

#declare T_Boca = texture {
	pigment { color rgb <0,0,0> }
	finish	{ ambient 0.5 diffuse 0.7 specular 0.9 phong 1 phong_size 250 }
	}

// ----------------------------------------------

#declare RO=0.475;
#declare GO=0.025;

#declare Parpado0=intersection {
	sphere	{ <0,0,0> RO+GO }
	box	{ <-RO-GO-0.01,-RO-GO-0.01,RO+GO+0.01> <RO+GO+0.01,RO+GO+0.01,0> }
	texture { T_Cabeza }
	}

#macro OJO(A)
union	{
	sphere	{
		<0,0,0> RO
		texture { T_Ojos }
		}
	sphere	{
		<0,0,-0.09> RO-0.075
		texture { T_Ojos2 }
		}
	object	{
		Parpado0
		rotate x*A
		}
	object	{
		Parpado0
		rotate -x*A
		}
	translate < 0, 0.5, -0.6>
	}
#end

#macro Cabeza(A1)
union	{
	difference {
		union	{
			sphere	{ <0,0,0> 1 }
			sphere	{
				<0,0,0> 0.4
				scale <1,1,2>
				translate -z*0.7
				}
			sphere	{
				<0,0,0> 0.33
				scale <2,1,2>
				translate <0,-0.7,-0.425>
				}
			}
		box	{
			<0.85,0.34,0> <-0.8,-0.45,-0.5>
			rotate -x*30
			translate <0,-0.7,-0.75>
			}
		cylinder {
			<0,0,0> <0,0,-0.5> 0.2
			scale <2.5,0.75,2>
			translate <0,-0.7,-0.5>
			texture { T_Boca }
			}
		texture { T_Cabeza }
		}
	object	{ OJO(A1) translate x*0.5 }
	object	{ OJO(A1) translate -x*0.5 }
//	rotate x*A1
	}
#end


#declare Gpata=0.2;

#macro Pata(A0,A1,A2,A3)
#local L1=2;
#local L2=2;
#local L3=0.75;
union	{
	sphere	{ <0,0,0> Gpata }
	cylinder { <0,0,0> <0,-L1,0> Gpata }
	union	{
		sphere	{ <0,0,0> Gpata }
		cylinder { <0,0,0> <0,-L2,0> Gpata }
		union	{
			sphere	{ <0,0,0> Gpata }
			sphere	{ <0,0,0> 1 scale <Gpata*2,Gpata,L3> translate -z*(L3-Gpata) }
			rotate x*A3
			translate -y*L2
			}
		rotate x*A2
		translate -y*L1
		}
	rotate x*A1
	rotate y*A0
	texture { T_Patas }
	}
#end

#macro Pulga(A1,A2,A3,A4,A5)
#local Dx= 1;
#local Dy= -0.75;
#local Dz= 0.5;
union	{
	Cabeza(A1)
	object { Pata(-A2,A3,A4,A5) translate <Dx,Dy,Dz> }
	object { Pata(A2,A3,A4,A5) translate <-Dx,Dy,Dz> }
	cylinder {
		<-Dx,Dy,Dz> <Dx,Dy,Dz> Gpata
		texture { T_Patas }
		}
	scale 5
	}
#end

// ----------------------------------------------


#declare W=36;
#declare H=36;
#declare CI=8;

#declare Params = array[2][5] {
	{ 45,10,110,-170,60 },
	{ 45,10,-20,-30,-60 },
	}

#macro IP(P0,P1,Idx,N)
	P0+(P1-P0)*I/N
#end

#macro IK(P,S)
	IP(Params[0][P], Params[1][P], S, CI)
#end

//#declare A1= -50;
//#declare A2=  50;
//#declare D=180/(CI+1);
//#declare E=(A2-A1)/(CJ-1);

#declare X0=-image_width/2+W/2;
#declare Y0=+image_height/2-9;

