#include "ortomac.inc"

OrtoCamera(image_width,image_height,0,0)
//OrtoCamera(image_width,image_width*3/4,0,0)
OrtoLightS()

// ----------------------------------------------

#declare W=16;
#declare H=16;
#declare CI=8;
#declare CJ=8;

// ----------------------------------------------

#declare K=0.3;
#declare R0= seed(0);

#macro Textu(A,B)
texture {
	pigment { color rgb < K+(1-K)*A/CI, K+(1-K)*B/CJ, rand(R0)> }
	finish	{ ambient 0.4 diffuse 0.7 phong 10000 }
	}
#end

// ----------------------------------------------

#macro Tile(A,B)
//sphere	{
//	<0,0,0> 1
superellipsoid {
	<0.25, 0.25>
	Textu(A,B)
	scale (W-1)/2
	}
#end

// ----------------------------------------------

#declare X0=-image_width/2+W/2;
#declare Y0= image_height/2-H/2;
#declare I=0;
#while(I<CI)
	#declare J=0;
	#while(J<CJ)
		#if (I | J)
			object	{
				Tile(I,J)
				translate <X0+I*W,Y0-J*H,0>
				}
		#end
		#declare J=J+1;
	#end
	#declare I=I+1;
#end
