#include "animatic.h"

Animatic::Animatic ()
{
start = pc = 0;
ticks = count=0;
loopf = false;
runf = false;
}

void Animatic::setSequence (unsigned char* seq, int t)
{
ticks=t;
if(start != seq)
	{
	pc = start = seq;
	count=0;
	frame = *pc;
	}
}

void Animatic::rewind ()
{
pc = start;
count=0;
frame = *pc;
}

void Animatic::setTicks (int t)
{
ticks=t; count=0;
}

void Animatic::setLoop (bool f)
{
loopf = f;
}

void Animatic::setRun (bool f)
{
runf = f;
}

void Animatic::advance ()
{
if(start && runf)
	{
	if(count<ticks)
		count++;
	else	{
		count=0;
		if(pc[1] == End)
			{
			if(loopf)
				pc = start;
			}
		else	pc++;
		frame = *pc;
		}
	}
}
