#include <string.h>
#include "mapa.h"

#define	MAXBFLINE	256

Mapa::Mapa ()
{
width = height = 0;
mask_test = 0xFF;
mask_attr = 0;
mask_tile = 0;
mapa = 0;
}

Mapa::~Mapa ()
{ if(mapa) delete[] mapa; }

bool Mapa::read (FILE* fp)
{
char	bfline[MAXBFLINE];
int	c, nx=0, ny=0, f=0;
while((c=fgetc(fp))!=EOF)
	{
	if(c == '*')
		{
		if(fgets(bfline, MAXBFLINE, fp))
			sscanf(bfline, "%d %d %d", &nx, &ny, &f);
		break;
		}
	}
if(alloc(nx,ny))
	{
	mask_attr = f;
	for(c=0; c<ny; c++)
		{
		if(fgets(bfline, MAXBFLINE, fp))
			{
			CTile* p = tile(0,c);
			memcpy(p, bfline, nx);
			}
		else	break;
		}
	if(c==ny)
		return true;
	free();
	}
return false;
}

bool Mapa::copy (Mapa &source)
{
if(alloc(source.width, source.height))
	{
	memcpy(mapa, source.mapa, width*height);
	return true;
	}
return false;
}

bool Mapa::alloc (int w, int h)
{
if(w>0 && h>0)
	{
	if(mapa) delete[] mapa;
	mapa = new CTile[w*h];
	if(mapa){
		width = w;
		height = h;
		return true;
		}
	else	width = height = 0;
	}
return false;
}

void Mapa::free ()
{
if(mapa) delete[] mapa;
width = height = 0;
mapa = 0;
}

void Mapa::fill (CTile c)
{
if(mapa) memset(mapa, c, width*height);
}

/*@**********************************************************************
* 
************************************************************************/

MapaSet::MapaSet()
{
nmapas=0; mapas=0;
}

MapaSet::~MapaSet()
{
if(mapas)
	delete[] mapas;
}

int MapaSet::load (char *fname)
{
FILE	*fp = fopen(fname, "r");
if(fp)	{
	if(mapas)
		delete[] mapas;
	nmapas = 0;
	fscanf(fp, "%d", &nmapas);
	if(nmapas>0)
		{
		int	i;
		mapas = new Mapa[nmapas];
		if(mapas)
			{
			for(i=0; i<nmapas; i++)
				{
				if(!mapas[i].read(fp))
					break;
				}
			if(i!=nmapas)
				{
				delete[] mapas;
				nmapas=0;
				}
			}
		else	nmapas=0;
		}
	fclose(fp);
	}
return nmapas;
}
