#include "punq.h"
#include "oruga.h"

#define	VELOC	0.25

QCanvasPixmapArray *qpa_oruga = 0;

// -----------------------------------------------------

unsigned char ani_repta[] = {
	0, 1, 2, 3, 4, 5, 6, 7, 6, 5, 4, 3, 2, 1,
	Animatic::End };

Oruga::Oruga(int x, int y):Sprite(theGame)
{
if(!qpa_oruga)
	qpa_oruga=load_pixmap_array("oruga.png", 8, 2, 32, 17);
setSequence(qpa_oruga);
setX(x);
setY(y);
setZ(10);
setFrame(0);
setVisible(true);
setVelocity(VELOC,0);
ani.setSequence(ani_repta,3);
ani.setRun(true);
ani.setLoop(true);
}

void Oruga::advance ( int stage )
{
if(stage)
	{
	setX(x()+xVelocity());
	setFrame(2*ani.frame+(xVelocity()>0));
	ani.advance();
	}
else	{
	if(theGame->scene() == &sce_juega && boundingRect().intersects(thePulga->boundingRect()))
		{
		theGame->setScene(&sce_fracaso);
		setXVelocity(0);
		}
	else	{
		int schok = theGame->mapCollides(boundingRectAdvanced());
		if(schok)
			{
			if((schok&CM_CENTER_LEFT) || !(schok&CM_LEFT_DOWN))
				setXVelocity(VELOC);
			else if((schok&CM_CENTER_RIGHT) || !(schok&CM_RIGHT_DOWN))
				setXVelocity(-VELOC);
			}
		}
	}
}

QRect Oruga::boundingRect () const
{
QRect rec = QCanvasSprite::boundingRect();
rec.moveBy(-2,0);
rec.setWidth(32+4);
rec.setHeight(17+2);
return rec;
}

