#include <stdio.h>
#include "punq.h"
#include "pulga.h"

QCanvasPixmapArray *qpa_pulga;

// -----------------------------------------------------

#define	PULDX	36
#define	PULDY	36

#define	PICLINES	3

#define	LP(i)	(PICLINES*i)
#define	RP(i)	(PICLINES*i+1)
#define	CP(i)	(PICLINES*i+2)
#define	FP(i)	(PICLINES*8+i)

#define	END	Animatic::End

unsigned char ani_jump1_left[] = {
	LP(0), LP(1), LP(2), LP(3),
	LP(4), LP(5), LP(6), LP(7),
	END };
unsigned char ani_jump1_right[] = {
	RP(0), RP(1), RP(2), RP(3),
	RP(4), RP(5), RP(6), RP(7),
	END };

unsigned char ani_jump2_left[] = {
	LP(7), LP(6), LP(5), LP(4),
	LP(3), LP(2),
	END };
unsigned char ani_jump2_right[] = {
	RP(7), RP(6), RP(5), RP(4),
	RP(3), RP(2),
	END };

unsigned char ani_cae_left[] = {
	CP(1), CP(2), CP(3), CP(4),
	CP(5), CP(6), CP(7), CP(0),
	END };
unsigned char ani_cae_right[] = {
	CP(7), CP(6), CP(5), CP(4),
	CP(3), CP(2), CP(1), CP(0),
	END };

unsigned char ani_reposo[] = {
	FP(0), FP(1), FP(2), FP(2), FP(1),
	END };

bool Pulga::init()
{
int	n;
QList<QPixmap> qpm;
qpm.setAutoDelete(true);
n = add_pixmaps(qpm, "pulga.png", 9, PICLINES, PULDX, PULDY);
if(n)	{
	QList<QPoint> qpt;
	qpt.setAutoDelete(true);
	add_points(qpt, n, 0, 0);
	qpa_pulga = new QCanvasPixmapArray(qpm, qpt);
	return true;
	}
return false;
}

Pulga *thePulga = 0;

Pulga::Pulga(int x, int y) : Sprite(theGame) 
{
if(!qpa_pulga)
	init();
setSequence(qpa_pulga);
setX(x);
setY(y);
setZ(20);
setVelocity(0, -0.1);
setVisible(true);
thePulga = this;
ani.setSequence(ani_reposo);
status = CAYENDO;
}

Pulga::~Pulga()
{
thePulga = 0;
}

void Pulga::jump (double fuerza)
{
setXVelocity(fuerza);
setYVelocity(fuerza>0?-fuerza:fuerza);
buttonsOff();
ani.setRun(true);
status = SALTANDO1;
}

void Pulga::ready (bool left)
{
ani.setRun(false);
ani.setSequence(left ? ani_jump1_left : ani_jump1_right);
status = PREPARADO;
}

void Pulga::advance (int stage)
{
if(stage)
	{
	double vx = xVelocity();
	double px = x()+vx;
	double vy = yVelocity();
	double py = y()+vy;
	setX(px);
	setY(py);
	if(py<1)
		theGame->setScene(&sce_exito);
	if(schok)
		{
		if(status == SALTANDO1 || status == SALTANDO2)
			status = CAYENDO;
		if((schok&CM_DOWN)==CM_DOWN)
			{
			if(status == CAYENDO)
				{
				buttonsOn();
				ani.setLoop(false);
				ani.setSequence(ani_reposo);
				status = REPOSO;
				}
			}
		else	{
			ani.setLoop(true);
			if(schok&(CM_CENTER_LEFT|CM_CENTER_RIGHT|CM_UP))
				ani.setSequence(xVelocity()<0 ? ani_cae_right : ani_cae_left, 4);
			else if(!(schok&CM_RIGHT_DOWN))
				{
				setX(px+PULDX/4);
				schok = 0;
				ani.setSequence(ani_cae_right, 4);
				}
			else if(!(schok&CM_LEFT_DOWN))
				{
				setX(px-PULDX/4);
				schok = 0;
				ani.setSequence(ani_cae_left, 4);
				}
			}
		setXVelocity(0);
		setYVelocity(0);
		}
	else if(status == SALTANDO1)
		{
		if(yVelocity()>0)
			{
			ani.setSequence(xVelocity()<0 ? ani_jump2_left : ani_jump2_right);
			status = SALTANDO2;
			}
		}
	if(!(schok&CM_DOWN))
		{
		setYVelocity(yVelocity()+0.2);
		}
	setFrame(ani.frame);
	ani.advance();
	}
else	schok = mapCollides();
}

QRect Pulga::boundingRect () const
{
QRect rec = QCanvasSprite::boundingRect();
rec.moveBy(8,0);
rec.setWidth(20);
rec.setHeight(20);
return rec;
}
