#include <qbitmap.h>
#include <qimage.h>
#include "game.h"

Sprite::Sprite(Game *g) : QCanvasSprite(0,g) 
{
flags = 0;
//setVisible(true);
setActive(true);
setEnabled(true);
setAnimated(true);
}


void Sprite::kill ()
{
if(flags&_KILLED)
	return;
Game* g = (Game*)canvas();
g->delitems.append(this);
flags|=_KILLED;
}

int Sprite::mapCollides()
{
Game* g = (Game*)canvas();
int schok = g->mapCollides(boundingRectAdvanced());
if(schok)
	{
	double	vx = xVelocity();
	double	vy = yVelocity();
	double	dx = vx;
	double	dy = vy;
	double	vx0 = 0, vy0 = 0;
	int	f = schok;
	while((dx > 0.5 || dx < -0.5) || (dy > 0.5 || dy < -0.5))
		{
		dx = dx/2;
		dy = dy/2;
		if(f)	{
			vx = vx-dx;
			vy = vy-dy;
			schok = f;
			}
		else	{
			vx0 = vx;
			vy0 = vy;
			vx = vx+dx;
			vy = vy+dy;
			}
		setXVelocity(vx);
		setYVelocity(vy);
		f = g->mapCollides(boundingRectAdvanced());
		}
	if(f)	{
		setXVelocity(vx0);
		setYVelocity(vy0);
		}
	}
return schok;
}

#ifdef BRDEBUG

void Sprite::draw ( QPainter & painter )
{
QCanvasSprite::draw(painter);
painter.setPen(QColor(255,255,255));
painter.drawRect(boundingRect());
painter.flush();
}

#endif

// -----------------------------------------------------

int add_pixmaps(QList<QPixmap> &qpm, const char* fname, int ci, int cj, int dx, int dy)
{
QImage	img(fname);
if(img.isNull())
	return 0;
int	count=0;
int	i, j;
for(i=0; i<ci; i++)
	for(j=0; j<cj; j++)
		{
		QRect rec(i*dx,j*dy,dx,dy);
		QPixmap *pic = new QPixmap();
		*pic = img.copy(rec);
		pic->setMask(pic->createHeuristicMask());
		qpm.append(pic);
		count++;
		}
return count;
}

void add_points(QList<QPoint> &qpt, int n, double x, double y)
{
int	i;
for(i=0; i<n; i++)
	qpt.append(new QPoint(x,y));
}

QCanvasPixmapArray *load_pixmap_array(const char *fname, int cols, int rows, int width, int height)
{
int	n;
QCanvasPixmapArray *qpa;
QList<QPixmap> qpm;
qpm.setAutoDelete(true);
n=add_pixmaps(qpm, fname, cols, rows, width, height);
if(n)	{
	QList<QPoint> qpt;
	qpt.setAutoDelete(true);
	add_points(qpt, n, 0, 0);
	qpa = new QCanvasPixmapArray(qpm, qpt);
	return qpa;
	}
return 0;
}
