#include <stdio.h>
#include "visor.h"

Visor::Visor(QWidget *parent, const char *name) : QCanvasView(0, parent, name)
{
setHScrollBarMode(AlwaysOff);
setVScrollBarMode(AlwaysOff);
mpress = false;
}

void Visor::setView(int x, int y, bool update)
{
QCanvas *c=canvas();
int cdx = c->width(); 
int cdy = c->height(); 
dx = visibleWidth();
dy = visibleHeight();
if((cdx-dx)<x)
	x=cdx-dx;
if(x<0)	x=0;
if((cdy-dy)<y)
	y=cdy-dy;
if(y<0)	y=0;
x0 = x; y0 = y;
x1 = x0+dx; y1 = y0+dy;
if(update)
	setContentsPos(x0, y0);
}

void Visor::showRect(const QRect &rec, bool update)
{
bool r = false;
if(rec.right()>x1)
	{ x0 = rec.right()-dx; r=true; }
if(rec.x()<x0)
	{ x0 = rec.x(); r=true; }
if(rec.bottom()>y1)
	{ y0 = rec.bottom()-dy; r=true; }
if(rec.y()<y0)
	{ y0 = rec.y(); r=true; }
if(r)	{
	if(x0<0) x0=0;
	if(y0<0) y0=0;
	setView(x0, y0, update);
	}
}

void Visor::updateView()
{
setContentsPos(x0, y0);
}

Visor::~Visor()
{
}

void Visor::viewportMousePressEvent(QMouseEvent* e)
{
mx=e->x();
my=e->y();
mpress = true;
}

void Visor::viewportMouseReleaseEvent(QMouseEvent* e)
{
mx=e->x();
my=e->y();
mpress = false;
}

void Visor::viewportMouseMoveEvent(QMouseEvent* e)
{
mx=e->x();
my=e->y();
}
